/* USER CODE BEGIN Header */
/****************************************************************************\
* 		示例解包文件使用示例-HAL库函数版V1.0 2022.08.26
* 		支持型号：TOFSense/TOFSense-P/PS/F/FP/M/MS
* 		官方网站：https://www.nooploop.com/
* 		淘宝店铺： https://nooploop.taobao.com/
* 		深圳空循环科技有限公司
* 		用精准定位技术为行业赋能！
\****************************************************************************/
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "dma.h"
#include "usart.h"
#include "gpio.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */

/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/

/* USER CODE BEGIN PV */

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */
#define mode_flag  2 		//0:主动输出模式   1:查询输出模式    2:级联模式

uint8_t TOF_ID = 0;			//仅用作级联时更矮查询命令
uint8_t u_tx_buf[8] = { 0x57,0x10,0xff,0xff,0x00,0xff,0xff,0x63};  //查询命令
uint8_t u_rx_buf[400];

uint32_t TOF_data_length=0;		//DMA接收数据长度


/*TOFSense/TOFSense-P/PS/F/FP等型号的解包数据结构体*/
typedef struct {
	uint8_t ID;

	float dis;					//解包后的距离数据
	uint8_t status;				//解包后的信号状态指示
	uint16_t signal_strength;	//解包后的信号强度
}Tofsense;
static Tofsense TOF[8];

/*TOFSenseM/MS型号的解包数据结构体*/
typedef struct {
	uint8_t pixel_count;		//8x8 or 4x4
	uint8_t ID;

	float dis[64];					//解包后的距离数据
	uint8_t status[64];				//解包后的信号状态指示
	uint16_t signal_strength[64];	//解包后的信号强度
}Tofsense_M;
static Tofsense_M TOF_M[8];

/******************************************************************************
函数名称 ： Tof_Unpack_Data
函数功能 ： 将接收到模块的一帧数据传入解包函数，并将解包后的数据存入结构体变量中
参    数 ： 无
返 回 值 ： 无
调用方法：在空闲中断中调用Tof_Unpack_Data();进行赋值
支持模块：TOFSense/TOFSense-P/PS/F/FP
*******************************************************************************/
void Tof_Unpack_Data()
{
	uint8_t tof_flag,tof_id;

	tof_flag = g_nts_frame0.UnpackData(u_rx_buf,TOF_data_length);		//获取解包标志位
	tof_id = g_nts_frame0.result.id;									//获取该帧数据的模块ID
	if(tof_flag == 1){													//解包成功
		TOF[tof_id].ID = tof_id;
		TOF[tof_id].dis = g_nts_frame0.result.dis;
		TOF[tof_id].status = g_nts_frame0.result.dis_status;
		TOF[tof_id].signal_strength = g_nts_frame0.result.signal_strength;
	}
}
/******************************************************************************
函数名称 ： TofM_Unpack_Data
函数功能 ： 将接收到模块的一帧数据传入解包函数，并将解包后的数据存入结构体变量中
参    数 ： 无
返 回 值 ： 无
调用方法：在空闲中断中调用TofM_Unpack_Data();进行赋值
支持模块：TOFSense-M/MS
*******************************************************************************/
void TofM_Unpack_Data()
{
	uint8_t tofm_flag,tofm_id;

	tofm_flag = g_ntsm_frame0.UnpackData(u_rx_buf,TOF_data_length);		//获取解包标志位
	tofm_id = g_ntsm_frame0.id;											//获取该帧数据的模块ID
	if(tofm_flag == 1)													//解包成功
	{
		TOF_M[tofm_id].ID = tofm_id;
		TOF_M[tofm_id].pixel_count = g_ntsm_frame0.pixel_count;
		for(int i=0;i<TOF_M[tofm_id].pixel_count;i++)
		{
			TOF_M[tofm_id].dis[i] = g_ntsm_frame0.pixels[i].dis;
			TOF_M[tofm_id].status[i] = g_ntsm_frame0.pixels[i].dis_status;
			TOF_M[tofm_id].signal_strength[i] = g_ntsm_frame0.pixels[i].signal_strength;
		}
	}
}
/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */

  /* USER CODE END 1 */

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_DMA_Init();
  MX_USART1_UART_Init();
  /* USER CODE BEGIN 2 */
	__HAL_UART_ENABLE_IT(&huart1,UART_IT_IDLE);
  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  while (1)
  {
	  if(mode_flag == 0)													//主动输出模式
	{
	}
	else if(mode_flag == 1)												//查询输出模式
	{
		HAL_UART_Transmit_DMA(&huart1,u_tx_buf,sizeof(u_tx_buf));
		HAL_Delay(5);
	}
	else if(mode_flag == 2)												//级联模式
	{
		HAL_UART_Transmit_DMA(&huart1,u_tx_buf,sizeof(u_tx_buf));
		HAL_Delay(5);
		TOF_ID++;
		if(TOF_ID >= 8)
		{
			TOF_ID = 0;
		}
	  	u_tx_buf[4] = TOF_ID;										//更新ID
	  	u_tx_buf[7] = TOF_ID + 0x63;								//更新校验和
	}
    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */
  }
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Configure the main internal regulator output voltage
  */
  __HAL_RCC_PWR_CLK_ENABLE();
  __HAL_PWR_VOLTAGESCALING_CONFIG(PWR_REGULATOR_VOLTAGE_SCALE1);

  /** Initializes the RCC Oscillators according to the specified parameters
  * in the RCC_OscInitTypeDef structure.
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLM = 4;
  RCC_OscInitStruct.PLL.PLLN = 168;
  RCC_OscInitStruct.PLL.PLLP = RCC_PLLP_DIV2;
  RCC_OscInitStruct.PLL.PLLQ = 4;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }

  /** Initializes the CPU, AHB and APB buses clocks
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV4;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV2;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_5) != HAL_OK)
  {
    Error_Handler();
  }
}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */
  __disable_irq();
  while (1)
  {
  }
  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */
